models/Peliculas.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "peliculas".
 *
 * @property int $id
 * @property string $titulo
 * @property string|null $descripcion
 * @property int|null $duracion
 * @property string|null $fechaEstreno
 * @property string $categoria
 * @property string $portada
 * @property string|null $director
 * @property int|null $destacada
 * @property int|null $peliculaSemana
 */
class Peliculas extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'peliculas';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'titulo', 'categoria', 'portada'], 'required'],
            [['id', 'duracion', 'destacada', 'peliculaSemana'], 'integer'],
            [['fechaEstreno'], 'safe'],
            [['titulo'], 'string', 'max' => 100],
            [['descripcion'], 'string', 'max' => 255],
            [['categoria', 'portada', 'director'], 'string', 'max' => 50],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'titulo' => 'Titulo',
            'descripcion' => 'Descripcion',
            'duracion' => 'Duracion',
            'fechaEstreno' => 'Fecha de Estreno',
            'categoria' => 'Categoria',
            'portada' => 'Portada',
            'director' => 'Director',
            'destacada' => 'Destacada',
            'peliculaSemana' => 'Pelicula Semana',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Peliculas;
use yii\data\ActiveDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $pelicula= Peliculas::find()
                ->where(['peliculaSemana'=>1])
                ->one();
                
        return $this->render('index',[
            'pelicula' => $pelicula->portada,
            'id'=>$pelicula->id
        ]);
    }
    
    public function actionListado(){
        $dataProvider=new ActiveDataProvider([
            'query' => Peliculas::find(),
            'pagination' => [
                'pageSize' => 5,
            ],
        ]);
        
        return $this->render("listado",[
            "dataProvider" => $dataProvider,
        ]);
    }
    
    public function actionDestacadas(){
        $dataProvider=new ActiveDataProvider([
            'query' => Peliculas::find()->where(['destacada'=>1])
        ]);
        
        return $this->render("destacadas",[
            "dataProvider" => $dataProvider,
        ]);
    }
    
    public function actionCategorias(){
        $dataProvider=new ActiveDataProvider([
            'query' => Peliculas::find()->select('categoria')->distinct()
        ]);
        
        return $this->render("categorias",[
            "dataProvider" => $dataProvider,
        ]);

    }
    
    /**
     * accion que me muestra la pelicula sobre la que he realizo clic 
     * en la pagina de inicio
     */
    public function actionVerpelicula($id){
        $pelicula= Peliculas::findOne($id);
        
        return $this->render("verPelicula",[
            "pelicula" => $pelicula
        ]);
    }
    
    /**
     * Accion que me muestra las peliculas de una determinada categoria
     * seleccionada en la vista _categoria
     * @param type $categoria categoria seleccionada
     * @return vista donde me va a mostrar las peliculas
     */
    
    public function actionVer($categoria){
        $dataProvider=new ActiveDataProvider([
            "query" => Peliculas::find()->where(["categoria"=>$categoria]),
            'pagination' => [
                'pageSize' => 5,
            ],
        ]);
        
        return $this->render("ver",[
            "dataProvider" =>$dataProvider,
            "categoria"=>$categoria
        ]);
    }
    
    /**
     * Accion que me muestra las peliculas de una determinada categoria
     * selecciona en la vista listado
     * @param type $id id de la pelicula seleccionada
     * @return vista vergrid que me muestra las peliculas de la categoria de la pelicula seleccionada
     */
    
    
    public function actionVergrid($id){ //me llega un 1
        
        // saco la categoria de la pelicula sobre la que he realizado clic (se envia la id)
        $categoria=Peliculas::findOne($id)->categoria;
        
        $dataProvider=new ActiveDataProvider([
            "query" => Peliculas::find()->where(["categoria"=>$categoria])
        ]);
        
        return $this->render("vergrid",[
            "dataProvider" => $dataProvider,
            "categoria" => $categoria,
        ]);
        
    }
  
    
    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'brandImage' => '@web/imgs/logo.png',
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Inicio', 'url' => ['/site/index']],
            ['label' => 'Listado', 'url' => ['/site/listado']],
            ['label' => 'Categorias', 'url' => ['/site/categorias']],
            ['label' => 'Destacadas', 'url' => ['/site/destacadas']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">Peliculas</p>
        <p class="float-right">Desarrollado por Ramon</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_categoria.php
<?php

use yii\helpers\Html;

echo Html::a($model->categoria,
        ['site/ver','categoria'=>$model->categoria],
        ['class'=>'col-lg-12 d-block p-4 mb-5 btn btn-primary']
        );

views/site/_destacada.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->portada",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->titulo ?><br></h2>
        <div class="bg-warning rounded p-2">Duracion:</div>
        <div class="p-1"><?= $model->duracion ?> minutos</div>
        <div class="bg-warning rounded p-2">Director:</div>
        <div class="p-1"><?= $model->director ?></div>
        <div class="bg-warning rounded p-2">Categoria:</div>
        <div class="p-1"><?= $model->categoria ?></div>
        <?=  
           Html::a("Ver mas..",
        ['site/verpelicula','id'=>$model->id],
        ['class'=>'btn btn-primary float-right']
        );
            
         ?><br>
    </div>
    
</div>

views/site/_ver.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->portada",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->titulo ?><br></h2>
        <div class="bg-warning rounded p-2">Duracion:</div>
        <div class="p-1"><?= $model->duracion ?> minutos</div>
        <div class="bg-warning rounded p-2">Director:</div>
        <div class="p-1"><?= $model->director ?></div>
        <?=  
           Html::a("Ver mas..",
        ['site/verpelicula','id'=>$model->id],
        ['class'=>'btn btn-primary float-right']
        );
            
         ?><br>
    </div>
    
</div>

views/site/categorias.php
<?php
use yii\widgets\ListView;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Categorias</h1>
    
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_categoria",
    "itemOptions" => [
        'class' => 'col-lg-4',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/destacadas.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de peliculas Destacadas</h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_destacada",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'Peliculas';

use yii\helpers\Html;

?>
<div class="site-index">

    <div class="body-content">

        <div class="row">
            <div class="col-lg-6 text-justify">
               <p>
                   El cine es un arte y una técnica. Es el arte de narrar historias mediante la proyección de imágenes, de allí que también se lo conozca con el nombre de séptimo arte. Y es la técnica que consiste en proyectar fotogramas, de forma rápida y sucesiva, para crear la ilusión de movimiento.
            Para la realización del cine es necesaria la concurrencia de muchas otras capacidades a nivel técnico, creativo y financiero, como el montaje, la fotografía, la dirección, el guionismo, la operación de cámaras, el sonido, la producción, etc., para lo cual es necesario todo un equipo de trabajo. Asimismo, pasa por varias etapas: el desarrollo, la preproducción, el rodaje, la posproducción y la distribución.
               </p>
            </div>
            <div class="col-lg-5 ml-5 p-3">
                <h2 class="text-center border border-secondary bg-secondary text-white rounded p-3 mb-5">Pelicula de la semana</h2>
                
                <?= 
                Html::a(    
                            Html::img("@web/imgs/$pelicula",[
                                'class' => 'img-fluid d-block mx-auto' 
                            ])
                        ,["site/verpelicula","id"=>$id]
                        ,['class'=>'']
                        );
        
                ?>
                
            </div>
        </div>

    </div>
</div>

views/site/listado.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de peliculas</h1>

<?= GridView::widget([
    "dataProvider" => $dataProvider,
    "layout"=>"{items}<br>{pager}<br>{summary}",
    "pager"=>[
        "options" => ["class"=>"row col-6"],
        "linkOptions"=>["class"=>"p-2 d-block w-100 h-100"],
        "disabledPageCssClass"=>"p-2 rounded d-block col-1 border",
        "activePageCssClass"=>"bg-light",
        "nextPageCssClass"=>"rounded d-block col-1 border",
        "prevPageCssClass"=>"rounded d-block col-1 border",
        "pageCssClass"=>"rounded d-block col-1 p-0 border",
    ],
    "columns"=>[
        'id',
        'titulo',
        [
            'attribute'=>'categoria',
            'label'=>'Categoria',
            'format'=>'raw',
            'value' => function($data){
                return Html::a(
                            $data->categoria,
                            ['site/vergrid',"id"=>$data->id],
                            ["class"=>'btn btn-info mx-auto d-block',"style"=>"width:100px"]
                        );
            } 
        ],
        [
            'attribute'=>'portada',
            'label'=>'Portada',
            'format'=>'raw',
            'value' => function($data){
                $url = "@web/imgs/$data->portada";
                return Html::img($url,['style'=>'width:200px','class'=>'img-fluid mx-auto d-block']); 
            } 
        ],
        'fechaEstreno',
    ],
    "options"=>[
        "class" => "text-center"
    ]
]) ?>

views/site/ver.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de peliculas de Categoria <?= $categoria ?></h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ver",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/verPelicula.php
<?php
use yii\widgets\DetailView;
use yii\helpers\Html;

echo DetailView::widget([
    "model" => $pelicula,
    "attributes"=>[
        'id',
        'titulo',
        'descripcion',
        'duracion',
        'fechaEstreno',
        'categoria',
        'director',
        'destacada',
        'peliculaSemana',
        [
            'label'=>'Portada',
            'format'=>'raw',
            'value' => function($data){
                $url = "@web/imgs/$data->portada";
                return Html::img($url,['style'=>'width:200px']); 
            } 
        ],
        
        
    ]
    
]);

views/site/vergrid.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de peliculas de Categoria <?= $categoria ?></h1>

<?php
echo GridView::widget([
    "dataProvider" => $dataProvider,
    "layout"=>"{items}<br>{pager}<br>{summary}",
    "pager"=>[
        "options" => ["class"=>"row col-6"],
        "linkOptions"=>["class"=>" d-block w-100 h-100"],
        "disabledPageCssClass"=>"rounded d-block col-1 border",
        "activePageCssClass"=>"bg-light",
        "nextPageCssClass"=>"rounded d-block col-1 border",
        "prevPageCssClass"=>"rounded d-block col-1 border",
        "pageCssClass"=>"rounded d-block col-1 p-0 border",
    ],
    "columns"=>[
        'id',
        'titulo',
        [
            'label'=>'Portada',
            'format'=>'raw',
            'value' => function($data){
                $url = "@web/imgs/$data->portada";
                return Html::img($url,['style'=>'width:200px','class'=>'img-fluid mx-auto d-block']); 
            } 
        ],
        'fechaEstreno',
    ],
     "options"=>[
        "class" => "text-center"
    ]                
]);